
class HdaAppSlideshowController < ApplicationController

  PICTURES = "#{HDA_BASE}/files/pictures/"

  def initialize
  end

  def index
    # this is a standard HDA variable, it shows to the right of
    # the logo
    @app_title = "Slideshow"

    @code = ""
    @links = []
    @channels = []

    return unless File.readable?(PICTURES)
    return unless (File.ftype(PICTURES) == "directory")
    # traverse a picture directory
    # for each directory:
    #   if there is an index.xml file, assume there is an album
    #   else, build an album from the pictures
    Dir.chdir(PICTURES) do
	num = 0
	Dir.glob("*").sort.reverse.each do | entry |
	    if (File.ftype(entry) == "directory")
		dirname = entry.gsub(/-/, ' ')
		dirname.gsub!(/\./, ' ')
		dirname.gsub!(/_/, ' ')
		if (Dir.glob(File.join(entry, "index.xml")).size == 1)
		    # assume it's a picasa index.xml file
	    	    picasa = do_picasa_code(num, entry, "index.xml")
	    	    @code << picasa["code"]
	    	    album_caption = picasa["caption"]
		    album_caption = dirname if (album_caption == "")
	    	    @links << [num, album_caption, "slideshow/picasa.png"]
	    	    @channels << { :items => do_picasa_mediarss(entry, "index.xml") }
		else
	    	    @code << do_dir_code(num, entry)
	    	    @links << [num, dirname, "slideshow/folder.png"]
	    	    @channels << { :items => do_dir_mediarss(entry) }
		end
		num = num +1
	    end
	end
    end
    url = url_for :action => 'mediarss', :id => (rand 1000)
    @app_headers << '<link rel="alternate" href="' + url + '" type="application/rss+xml" title="" id="gallery" />'
  end

  def mediarss
    @channels = []

    path = PICTURES + (params[:path] ? params[:path] : "")

    return unless File.readable?(path)
    return unless (File.ftype(path) == "directory")

    Dir.chdir(path) do
	Dir.glob("*").sort.each do | entry |
	    if (File.ftype(entry) == "directory")
		dirname = entry.gsub(/-/, ' ')
		dirname.gsub!(/\./, ' ')
		dirname.gsub!(/_/, ' ')
		if (Dir.glob(File.join(entry, "index.xml")).size == 1)
		    # FIXME: add the channel name!
	    	    @channels << { :items => do_picasa_mediarss(entry, "index.xml"), :path => entry }
		else
		    # FIXME: add the channel name!
	    	    @channels << { :items => do_dir_mediarss(entry), :path => entry }
		end
	    else
	    	@channels << { :items => [ do_file_mediarss(".", entry)], :path => entry }
	    end
	end
    end
    render :layout => false
  end

  require 'gd2'
  include GD2 

  def thumb

	max_width = params[:w] ? params[:w].to_i : 240
	max_height = params[:h] ? params[:h].to_i : 240

	filepath = PICTURES + params[:image]		# path to file
	format = filepath.split(".").last		# format - extension
	filename = params[:image].split(".").first	# just file name without extension(s)
	digest = Digest::MD5.hexdigest filepath		# md5 hash # require 'digest/md5'
	cachefile = digest + "-" + max_width.to_s + max_height.to_s + "." + format

	picfile = filepath
	cachedir = "/tmp/slideshows-thumb/" 
	begin
		Dir.mkdir cachedir
	rescue Errno::EEXIST
		true # ignore if it exist already
	end
	cachedpicfile = cachedir + cachefile

	if File.exists?(cachedpicfile) && (File.stat(cachedpicfile).mtime.to_i > File.stat(picfile).mtime.to_i)
		picsource = cachedpicfile
		# refresh the cache
		File.utime(t = Time.now, t, picsource)
		cache = true
	elsif File.exists? picfile 
		picsource = picfile
	end

	if cache
		# Read from the cache
		pic = File.new(picsource).read
	else	# or import the image
		i = Image.import(picsource)
		iw = i.size[0]
		ih = i.size[1]

		if iw > iw  # Horizontal proportion. width > height.
			width = (iw < max_width) ? iw : max_width
			height = ((width * ih.to_f) / iw.to_f).to_i
		else    # Vertical proportions
			height = (ih < max_height) ? ih : max_height
			width = (iw.to_f / (ih.to_f / height.to_f)).to_i

		end
		i.resize! width, height
		pic = i.png
		i.export(cachedpicfile) # export cache file
	end
	send_data(pic, :disposition => 'inline', :type => 'image/jpg', :filename => filepath)
    end  

protected

  # DEBUG
  # require 'cgi'
  # require 'strscan'
  # do_picasa_code(0, "/var/hda/files/pictures/060721-entrada-cristianos-oliva", "index.xml")
  # dir = "/var/hda/files/pictures/060721-entrada-cristianos-oliva"
  # indexfile = "index.xml"
  def do_picasa_code(num, dir, indexfile)
    res = ""
    res << "<script type=\"text/javascript\"><!--\n"
    res << "function openGallery#{num}() {\n"
    res << "   return Lightbox.open(["

    album = PicasaXML.new(File.join(dir,indexfile))
    images = album.images
    images.each do |path, caption|
	urla = dir.split('/') + path.split('/')
	urla.map! { |f| CGI::escape(f) }
	urla.map! { |f| f.gsub('+', '%20') }
	url = urla.join('/')
        caption.gsub!(/'/, '\\\'')
        caption.gsub!(/\\/, '\\\\')
	res << "['/_PIC/#{url}', '#{caption}'],"
    end
    res << " ], 0); }\n"
    res << "//--></script>\n"
    return { "code" => res, "caption" => album.caption }
  end

  def do_dir_code(num, dir)
    res = ""
    filetypes = Regexp.new('\.(jpg|png|gif)$', Regexp::IGNORECASE)
    res << "<script type=\"text/javascript\"><!--\n"
    res << "function openGallery#{num}() {\n"
    res << "   return Lightbox.open(["
    Dir.entries(dir).sort.each do |f|
	if (filetypes.match(f) and (f !~ /^\./))
	  url = '/_PIC/' + CGI::escape(dir) + '/' + CGI::escape(f)
	  url.gsub!('+', '%20')
          caption = f.gsub(/'/, '\\\'')
          caption.gsub!(/\\/, '\\\\')
          caption = CGI::escape(caption)
	  res << "['#{url}', '#{caption}'],"
	end
    end
    res << " ], 0); }\n"
    res << "//--></script>\n"
    rescue
	""
  end

  def do_picasa_mediarss(dir, indexfile)
    items = []
    album = PicasaXML.new(File.join(dir,indexfile))
    images = album.images
    images.each do |path, caption, thumbnail|
	urla = dir.split('/') + path.split('/')
	urla.map! { |f| CGI::escape(f) }
	urla.map! { |f| f.gsub('+', '%20') }
	url = '/_PIC/' + urla.join('/')
	thumba = dir.split('/') + thumbnail.split('/')
	thumba.map! { |f| CGI::escape(f) }
	thumba.map! { |f| f.gsub('+', '%20') }
	thumb = '/_PIC/' + thumba.join('/')
        caption.gsub!(/'/, '\\\'')
        caption.gsub!(/\\/, '\\\\')
	items << { :url => url, :caption => caption, :thumb => thumb }
    end
    items
  end

  def do_file_mediarss(dir, f)
    filetypes = Regexp.new('\.(jpg|png|gif)$', Regexp::IGNORECASE)
    if (filetypes.match(f) and (f !~ /^\./))
	url = '/_PIC/' + CGI::escape(dir) + '/' + CGI::escape(f)
	url.gsub!('+', '%20')
        caption = f.gsub(/'/, '\\\'')
        caption.gsub!(/\\/, '\\\\')
	{ :url => url, :caption => caption, :thumb => url_for(:action => 'thumb', :image => [dir, f].join('/'))  }
    # elsif (File.ftype(f) == "directory")
    #	[] # FIXME - recurse through directories
    else
	nil
    end
  end

  def do_dir_mediarss(dir)
    items = []
    filetypes = Regexp.new('\.(jpg|png|gif)$', Regexp::IGNORECASE)
    Dir.entries(dir).sort.each do |f|
	res = do_file_mediarss(dir, f)
	unless res.nil?
		items << res
	end
    end
    items
    rescue
	items
  end

end

# read the (broken) xml generated by picasa
class PicasaXML

  def initialize(fname)
    @doc = File.open(fname).readlines.join
    @re_image = Regexp.new('.*?<image>(.*?)</image>', Regexp::MULTILINE | Regexp::IGNORECASE)
    @re_path = Regexp.new('.*?<itemLargeImage>(.*?)</itemLargeImage>', Regexp::MULTILINE | Regexp::IGNORECASE)
    @re_caption = Regexp.new('.*?<itemCaption>(.*?)</itemCaption>', Regexp::MULTILINE | Regexp::IGNORECASE)
    @re_thumbnail = Regexp.new('.*?<itemThumbnailImage>(.*?)</itemThumbnailImage>', Regexp::MULTILINE | Regexp::IGNORECASE)
    @re_album = Regexp.new('.*?<albumCaption>(.*?)</albumCaption>', Regexp::MULTILINE | Regexp::IGNORECASE)
  end

  def images(string = @doc)
	ss = StringScanner.new(string)
	res = []
	loop do
        	ss.scan @re_image or break
		img_ss = StringScanner.new(ss[1])
		img_ss.scan @re_path
		path = img_ss[1].strip
		img_ss.reset
		img_ss.scan @re_thumbnail
		thumbnail = img_ss[1].strip
		img_ss.reset
		img_ss.scan @re_caption
		caption = img_ss[1].strip
		res << [path, caption, thumbnail]
	end
	return res
  end

  # album caption
  def caption(string = @doc)
	ss = StringScanner.new(string)
	ret = ""
        ss.scan @re_album
	ret << ss[1]
	return ret.strip
  end

  def image_path(string)
	ss = StringScanner.new(string)
	ret = ""
        ss.scan @re_path
	ret << ss[1]
	return ret.strip
  end

  def image_caption(string)
	ss = StringScanner.new(string)
	ret = ""
        ss.scan @re_caption
	ret << ss[1]
	return ret.strip
  end

end
