class HdaAppSlideshowInstaller
  def up
    appname = "slideshow"
    app = "hda_app_" + appname
    tgt = "#{HDA_BASE}/platform/html"
    FileUtils.cd("#{HDA_BASE}/platform/apps/slideshow") do
      FileUtils.cp("app/controllers/hda_app_slideshow_controller.rb", "#{tgt}/app/controllers")
      FileUtils.cp("app/helpers/hda_app_slideshow_helper.rb", "#{tgt}/app/helpers")
      FileUtils.cp("app/models/hda_app_slideshow.rb", "#{tgt}/app/models")
      FileUtils.mkdir_p("#{tgt}/app/views/hda_app_slideshow")
      FileUtils.cp_r("app/views/#{app}", "#{tgt}/app/views/")
      FileUtils.cp_r("public/slideshow", "#{tgt}/public/images/")
    end
    pid = HdaPackage.find(:first, :conditions => "name='slideshow'")[:id]
    HdaApplication.new(:hda_package_id => pid, :hda_user_id => 1).save
    load "#{tgt}/app/models/hda_app_slideshow.rb"
    load "#{tgt}/app/controllers/hda_app_slideshow_controller.rb"
    load "#{tgt}/app/helpers/hda_app_slideshow_helper.rb"
    true
  end

  def down
    appname = "slideshow"
    app = "hda_app_" + appname
    tgt = "#{HDA_BASE}/platform/html"
    FileUtils.cd(tgt) do
      FileUtils.rm("app/controllers/hda_app_slideshow_controller.rb", :force => true)
      FileUtils.rm("app/helpers/hda_app_slideshow_helper.rb", :force => true)
      FileUtils.rm("app/models/hda_app_slideshow.rb", :force => true)
      FileUtils.rm_r("app/views/#{app}", :force => true)
      FileUtils.rm_rf("public/images/#{app}")
    end
    pid = HdaPackage.find(:first, :conditions => "name='slideshow'")[:id]
    HdaApplication.find(:all, :conditions => "hda_package_id=#{pid}").each {|r| r.destroy}
    #Object.__send__(:remove_const, 'HdaAppSlideshowController')
    #Object.__send__(:remove_const, 'HdaAppSlideshowPhoto')
    #Object.__send__(:remove_const, 'HdaAppSlideshowHelper')
    true
  end

  def user_up u
    true
  end

end
